/**
 * Communication OSC avec Max
 * Comment envoyer des messages OSC vers Max.
 * oscP5 website : http://www.sojamo.de/oscP5
 */

// Importer la librairie oscP5
// netP5 est indispensable aussi
import oscP5.*;
import netP5.*;

// Port reseau, adresse reseau
OscP5 oscP5;
NetAddress vers_max;

void setup() {

  // Parametres graphiques
  size(200, 200);
  background(0);

  /* Ouverture d'un port 1349 pour la reception de messages depuis Max, 
   fonction non encore utilisee dans ce sketch.
   Un numero de port sert a recevoir des messages venant de l'exterieur. 
   Ce numero de port est arbitraire.
   */
  oscP5 = new OscP5(this, 1349);

  /* Definir une adresse 1234 vers qui envoyer des messages,
   comportant une adresse IP et un numero de port.
   Cette adresse est utilisee comme parametre de oscP5send().
   */
  vers_max = new NetAddress("127.0.0.1", 1234);
  // localhost = 127.0.0.1 = rester dans cet ordinateur
  // 1234 = numero de port que Max devra ecouter
}

void draw() {  
  background(0);
  /* Construction du message OSC a envoyer vers Max : en-tete et valeur.
   En-tete = pour savoir a qui s'adresser.
   Valeur : quelque chose de variable a envoyer a cet endroit.
   Quand on s'adresse a Max, les en-tete de messages sont /nom_de_l_entete
   */
  OscMessage myMessage = new OscMessage("/truc");
  // Ajout de la valeur de la souris au message
  myMessage.add(mouseX); 

  // Envoi du message.
  oscP5.send(myMessage, vers_max);
}

// Reception de messages OSC envoyes par Max
float slider1 ;

void oscEvent(OscMessage message_max) {
  // Trie les messages arrivant en fonction de leur adresse
  if (message_max.checkAddrPattern("/slidercapteur1")==true) {
    // Attribution de la valeur du message a une variable du meme type.
    slider1 = message_max.get(0).intValue();
    println(" Message /slidercapteur1 : "+slider1);
  }

}